<?php
class Thumbnail
{
	var $img;
	var $decr_only;
	function Thumbnail($imgfile,$decrease_size=null,$only_decrease=null)
	{
		$this->decr_only = ($only_decrease != null) ? True : False;
		if(function_exists("exif_imagetype") && $decrease_size == null) // More faster extension deceting function
		{
			$arr = @exif_imagetype($imgfile);
		}
		else
		{
			$val = @getimagesize($imgfile);
			$arr = $val[2];
			$this->img['dwidth']= intval($val[0]);
			$this->img['dheight'] = intval($val[1]);
		}
		switch($arr)
		{
			case '1':
				$this->img['format']='gif';
				$this->img['src'] = (function_exists('ImageCreateFromGIF')) ? ImageCreateFromGIF ($imgfile) : $this->ShowAsIs($imgfile);
				break;
			case '2':default:
				$this->img['format']='jpeg';
				$this->img['src'] = (function_exists('ImageCreateFromJPEG')) ? ImageCreateFromJPEG ($imgfile) : $this->ShowAsIs($imgfile);
				break;
			case '3':
				$this->img['format']='png';
				$this->img['src'] = (function_exists('ImageCreateFromPNG')) ? ImageCreateFromPNG ($imgfile) : $this->ShowAsIs($imgfile);
				break;
		}
		@$this->img['x'] = imagesx($this->img['src']);
		@$this->img['y'] = imagesy($this->img['src']);
		@$this->img['Quality']=75;
	}

	function ext($file)
	{
		if(function_exists("exif_imagetype")) // More faster extension detecting function
		{
			$arr = @exif_imagetype($file);
		}
		else
		{
			$val = @getimagesize($file);
			$arr = $val[2];
		}
		switch($arr)
		{
			case '1': return '.gif';break;
			case '2':default: return '.jpg';break;
			case '3': return '.png';break;
			case '4': return '.swf';break;
			case '5': return '.psd';break;
			case '6': return '.bmp';break;
			case '7': return '.tiff';break;
			case '8': return '.tiff';break;
			case '9': return '.jpc';break;
			case '10': return '.jp2';break;
			case '11': return '.jpx';break;
		}
	}

	function CheckFunctions()
	{
		Return (function_exists("ImageCreateTrueColor")) ? True : False;
	}

	function Height($size=100)
	{
		$this->img['y_thumb']=$size;
		@$this->img['x_thumb'] = ($this->img['y_thumb']/$this->img['y'])*$this->img['x'];
	}

	function Width($size=100)
	{
		$this->img['x_thumb']=$size;
		@$this->img['y_thumb'] = ($this->img['x_thumb']/$this->img['x'])*$this->img['y'];
	}

	function info()
	{
		echo $this->img['dwidth'];
		echo $this->img['dheight'];
	}
	
	function Auto($size=100)
	{
		if ($this->img['x']>=$this->img['y']) {
			$this->img['x_thumb']=$size;
			@$this->img['y_thumb'] = ($this->img['x_thumb']/$this->img['x'])*$this->img['y'];
		} else {
			$this->img['y_thumb']=$size;
			@$this->img['x_thumb'] = ($this->img['y_thumb']/$this->img['y'])*$this->img['x'];
		}
	}

	function Quality($Quality=75)
	{
		$this->img['Quality']=$Quality;
	}

	function ShowAsIs($Path)
	{
		if(!$this->decr_only)
		{
			header('Content-Type: image/'.$this->img['format']);
			header("Cache-control: public");
			header("Expires: ".date("r",mktime(0,0,0,1,1,2037)));
			header("Cache-control: max-age=".(60*60*24*7));
			header("Last-Modified: ".date("r",filemtime($Path)));
			$fp = fopen ($Path, "rb");
			$data = fread($fp, filesize($Path));
			#fpassthru($fp); // Alternate output
			fclose ($fp);
			Print $data;
			exit();
		} 
		else 
		{
			printm('Can`t decrease '.$this->img['format'].' file');
		}
	}

	function Show()
	{
		@Header('Content-Type: image/'.$this->img['format']);

		if ($this->CheckFunctions())
		$this->img['des'] = ImageCreateTrueColor($this->img['x_thumb'],$this->img['y_thumb']);
		else
		$this->img['des'] = ImageCreate($this->img['x_thumb'],$this->img['y_thumb']);

		@imagecopyresized ($this->img['des'], $this->img['src'], 0, 0, 0, 0, $this->img['x_thumb'], $this->img['y_thumb'], $this->img['x'], $this->img['y']);

		if ($this->img['format']=='jpg' || $this->img['format']=='jpeg')
		{
			if(function_exists('imageJPEG')) imageJPEG($this->img['des'],'',$this->img['Quality']);
			else Return False;
		}
		elseif ($this->img['format']=='png')
		{
			if(function_exists('imagePNG')) imagePNG($this->img['des']);
			else Return False;
		}
		elseif ($this->img['format']=='gif')
		{
			if(function_exists('imageGIF')) imageGIF($this->img['des']);
			else Return False;
		}
	}

	function Save($Save='',$decrease_size=null)
	{

		if($decrease_size!=null)
		{
			$maxsize = ($this->img['dwidth'] >= $this->img['dheight']) ? $this->img['dwidth'] : $this->img['dheight'];
			if(($this->img['x_thumb'] > $this->img['dwidth']) || ($this->img['y_thumb'] > $this->img['dheight']))
			{
				$this->img['x_thumb'] = $this->img['dwidth'];
				$this->img['y_thumb'] = $this->img['dheight'];
			}
		}
		if (empty($Save)) $Save=strtolower('./t'.$this->img['format']);

		if ($this->CheckFunctions())
		$this->img['des'] = ImageCreateTrueColor($this->img['x_thumb'],$this->img['y_thumb']);
		else
		$this->img['des'] = ImageCreate($this->img['x_thumb'],$this->img['y_thumb']);

		@imagecopyresized ($this->img['des'], $this->img['src'], 0, 0, 0, 0, $this->img['x_thumb'], $this->img['y_thumb'], $this->img['x'], $this->img['y']);
		if ($this->img['format']=='jpg' || $this->img['format']=='jpeg')
		{
			if(function_exists('imageJPEG')) imageJPEG($this->img['des'],$Save,$this->img['Quality']);
			else Return False;
		}
		elseif ($this->img['format']=='png')
		{
			if(function_exists('imagePNG')) imagePNG($this->img['des'],$Save);
			else Return False;
		}
		elseif ($this->img['format']=='gif')
		{
			if(function_exists('imageGIF')) imageGIF($this->img['des'],$Save);
			else Return False;
		}
	}
}
?>